<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class purchaseController {
    private $dbc;
    var $gateway;
    
    function __construct($gateway) {
    	$this->dbc = new DBCon();
        $this->gateway = $gateway;
    }
    
    function show() {
        if (!isset($_GET['step'])) {
            $_GET['step'] = "account";
        }
        $step = $_GET['step'];
        switch ($step) {
            case "download":
                $this->downloadPage();
                break;
            case "payment":
                $this->paymentPage();
                break;
            case "account":
                $this->accountPage();
                break;
            default:
                $this->accountPage();
                break;
        }
    }
    
    function accountPage() {
        $status = $this->purchaseCheck();
        if ($status > 1) {
            $this->downloadPage();
            return;
        } else if ($status == 1) {
            $this->paymentPage();
        }
        
        if (isset($_POST['register']) && $_POST['register']) {
            $error = "";
            if (!isset($_POST['first-name']) || !$_POST['first-name']) {
                $error = "The first name field is required.";
            }
            
            if (!isset($_POST['last-name']) || !$_POST['last-name']) {
                $error = "The last name field is required.";
            }
            
            if (!isset($_POST['email']) || !$_POST['email']) {
                $error = "The email address field is required.";
            }
            
            if (!isset($_POST['cemail']) || !$_POST['cemail']) {
                $error = "The confirm email address field is required.";
            }
            
            if (!isset($_POST['pw']) || !$_POST['pw']) {
                $error = "The password field is required.";
            }
            
            if (!isset($_POST['cpw']) || !$_POST['cpw']) {
                $error = "The confirm field is required.";
            }
            
            if ($_POST['pw'] != $_POST['cpw']) {
                $error = "The password and confirm password fields did not match.";
            }
            
            if ($_POST['email'] != $_POST['cemail']) {
                $error = "The email address and confirm email address fields did not match.";
            }
            
            if (!isset($_POST['terms']) || !$_POST['terms']) {
                $error = "Please accept the terms.";
            }
            
            if (email_exists($_POST['email'])) {
                $error = "The email you've provided is already in use.";
            }
            
            if (!filter_var($_POST['email'], FILTER_VALIDATE_EMAIL)) {
                $error = "The email you entered is not valid.";
            }
            
            if ($error != "") {
                include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_account.php');
                return;
            }
            
            $userdata = array('user_pass' => $_POST['pw'],
		            'first_name' => $_POST['first-name'],
		            'last_name' => $_POST['last-name'],
		            'user_login' => $_POST['email'],
		            'user_email' => $_POST['email'],
		            'display_name' => $_POST['first-name'] . ' ' . $_POST['last-name']);
            $user_id = wp_insert_user($userdata);
            wp_update_user( array ('ID' => $user_id, 'role' => 'subscriber') ) ;
            if ($user_id) {
                $address = esc_attr($_POST['address']);
                $address_two = esc_attr($_POST['address_two']);
                $city = esc_attr($_POST['city']);
                $state = esc_attr($_POST['state']);
                $zip = esc_attr($_POST['zip']);
                $country = esc_attr($_POST['country']);

                $shipping_info = array(
                    'address' => $address,
                    'address_two' => $address_two,
                    'city' => $city,
                    'state' => $state,
                    'zip' => $zip,
                    'country' => $country
                );
                update_user_meta($user_id, 'md_shipping_info', $shipping_info);
                
                $userToLogin = get_user_by('id', $user_id);
                wp_set_current_user($userToLogin->ID, $_POST['email']);
                wp_set_auth_cookie($userToLogin->ID);
                do_action('wp_login', $_POST['email'], $userToLogin);
                usleep(500);
                wp_redirect($_SERVER['REQUEST_URI'] . '?step=payment');
                exit();
            } else {
                $error = "Something went wrong. Please try again or contact customer service.";
                include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_account.php');
                return;
            }
        } else if ($_POST['login']) {
            $login_error = "";
            
            if (!isset($_POST['email']) || !$_POST['email']) {
                $login_error = "The email address field is required.";
            }
            
            if (!isset($_POST['password']) || !$_POST['password']) {
                $login_error = "The password field is required.";
            }
            
            if ($login_error != "") {
                include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_account.php');
                return;
            }
            
            $creds = array(
                'user_login'    => $_POST['email'],
                'user_password' => $_POST['password'],
                'remember'      => true
            );

            $user = $this->so_authenticate($_POST['email'], $_POST['password']);

            if (is_wp_error($user)) {
                $login_error = $user->get_error_message();
                include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_account.php');
                return;
            }
            
            $userToLogin = get_user_by('id', $user->ID);
            wp_set_current_user($userToLogin->ID, $_POST['email']);
            wp_set_auth_cookie($userToLogin->ID, false);
            do_action('wp_login', $_POST['email'], $userToLogin);
            header('Location: '.$_SERVER['REQUEST_URI'] . '?step=payment');
            return;
        }
        
        include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_account.php');
    }
    
    function so_authenticate($username, $password) {
        $username = sanitize_user( $username );
        $password = trim( $password );

        $user = apply_filters( 'authenticate', null, $username, $password );

        if ( $user == null ) {
            // TODO what should the error message be? (Or would these even happen?)
            // Only needed if all authentication handlers fail to return anything.
            $user = new WP_Error( 'authentication_failed', __( '<strong>ERROR</strong>: Invalid username, email address or incorrect password.' ) );
        }

        $ignore_codes = array( 'empty_username', 'empty_password' );

        return $user;
    }

    
    function paymentPage() {
        $status = $this->purchaseCheck();
        if ($status > 1) {
            $this->downloadPage();
            return;
        } else if ($status < 1) {
            $this->accountPage();
        }
        
        $token = $clientToken = $this->gateway->clientToken()->generate();
        
        if (isset($_POST['submit_payment']) && $_POST['submit_payment']) {
            $error = "";
            
            if (!isset($_POST['first-name']) || !$_POST['first-name']) {
                $error = "The first name field is required.";
            }
            
            if (!isset($_POST['address']) || !$_POST['address']) {
                $error = "Please enter an address.";
            }
            
            if (!isset($_POST['city']) || !$_POST['city']) {
                $error = "Please enter a city.";
            }
            
            if (!isset($_POST['state']) || !$_POST['state']) {
                $error = "Please enter a state.";
            }
            
            if (!isset($_POST['zip']) || !$_POST['zip']) {
                $error = "Please enter a zip code.";
            }
            
            if (!isset($_POST['country']) || !$_POST['country']) {
                $error = "Please enter a country.";
            }
            
            if (!isset($_POST["payment_method_nonce"]) || !$_POST["payment_method_nonce"]) {
                $error = "Invalid payment info. Please retry or contact customer service.";
            }
            
            if (!isset($_POST['terms']) || !$_POST['terms']) {
                $error = "Please accept the terms.";
            }
            
            if ($error != "") {
                include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_payment.php');
                return;
            }
            
            $address = esc_attr($_POST['address']);
            $address_two = esc_attr($_POST['address_two']);
            $city = esc_attr($_POST['city']);
            $state = esc_attr($_POST['state']);
            $zip = esc_attr($_POST['zip']);
            $country = esc_attr($_POST['country']);

            $shipping_info = array(
                'address' => $address,
                'address_two' => $address_two,
                'city' => $city,
                'state' => $state,
                'zip' => $zip,
                'country' => $country
            );
            update_user_meta($user_id, 'md_shipping_info', $shipping_info);
            
            $success = false;
            $current_user = wp_get_current_user();
            $email = (string) $current_user->user_email;
            $result = $this->gateway->customer()->create([
                'firstName' => $_POST["first-name"],
                'lastName' => $_POST["last-name"],
                'email' => $email,
                'creditCard' => array(
                    'paymentMethodNonce' => $_POST["payment_method_nonce"],
                    'options' => array(
                        'verifyCard' => true
                    )
                )
            ]);

            if ($result->success) {
                $status = $result->customer->creditCards[0]->verifications[0]["status"];
                if ($status != 'processor_declined' && $status != 'gateway_rejected' && $status != 'failed') {
                    $resultTrans = $this->gateway->transaction()->sale([
                        'amount' => '19.99',
                        'paymentMethodToken' => $result->customer->creditCards[0]->token,
                        'options' => [
                          'submitForSettlement' => True
                        ]
                    ]);
                    $statusTrans = $resultTrans->transaction->status;
                    if ($result->success && $statusTrans != 'processor_declined' && $statusTrans != 'gateway_rejected' && $statusTrans != 'failed') {
                        global $crowdfunding;
                        $reg_key = md5(round(microtime(true) * 1000));
                        $userInfo = wp_get_current_user();
                        $access_levels = array(absint(52));
                        $level = ID_Member_Level::get_level(52);
		        $user = array('user_id' => $userInfo->ID, 'level' => $access_levels, 'reg_key' => $reg_key, 'data' => array('ipn_id' => $resultTrans->transaction->id));
                        $user_id = $userInfo->ID;
                        $new = ID_Member::add_paypal_user($user);
                        $txn_id = $resultTrans->transaction->id;
                        $sub_id = $resultTrans->transaction->id;
			$order = new ID_Member_Order(null, $user_id, 52, null, $txn_id, $sub_id, 'active', null, 19.99);
			$new_order = $order->add_order();
			fwrite($log, 'order added: '.$new_order."\n");
			do_action('idmember_registration_email', $user_id, $reg_key, $new_order);
                        
                        if ($crowdfunding) {
                            $mdid_checkout = 1;
                            $project_id = 3;
                            $proj_level = 1;
                            $order = new ID_Member_Order($new_order);
                            $order_info = $order->get_order();
                            $created_at = $order_info->order_date;
                            $pay_id = mdid_insert_payinfo($user_id, $_POST["first-name"], $_POST["last-name"], $email, $project_id, $txn_id, $proj_level, 19.99, null, $created_at);
                            if (isset($pay_id)) {
                                $mdid_id = mdid_insert_order('', $pay_id, $new_order, null);
                            }
                        }
                        
                        $this->downloadPage($resultTrans->transaction->id);
                        return;
                    } else {
                        $error = "There was an error processing this transaction. Please try again or contact customer service.";
                        include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_payment.php');
                        return;
                    }
                } else {
                    $error = "The card was declined. Please try another card or contact customer service.";
                    include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_payment.php');
                    return;
                }
            } else {
                $error = "There was an error processing your request. Please try again or contact customer service.";
                include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_payment.php');
                return;
            }
        }
        
        include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_payment.php');
        return;
    }
    
    function downloadPage($transactionId = "") {
        if (is_user_logged_in()) {
            global $current_user;
            global $wpdb;
            get_currentuserinfo();

            $wp_user_id = $current_user->ID;
            $pledge_level = get_pledge_level($wp_user_id);
            $founder_level = get_founder_level($wp_user_id);
            $ea_level = get_ea_level($wp_user_id);
            if (isset($pledge_level) || isset($founder_level) || isset($ea_level)) {
                if ($pledge_level >= 1 || $founder_level >= 1 || $ea_level >= 1) {
                    $transId = $transactionId;
                    include_once(ABSPATH . 'wp-content/plugins/loa-braintree/views/purchase_download.php');
                } else {
                    $this->paymentPage();
                }
            } else {
                $this->paymentPage();
            }
        } else {
            $this->accountPage();
        }
    }
    
    function purchaseCheck() {
        if (is_user_logged_in()) {
            global $current_user;
            global $wpdb;
            get_currentuserinfo();

            $wp_user_id = $current_user->ID;
            $pledge_level = get_pledge_level($wp_user_id);
            $founder_level = get_founder_level($wp_user_id);
            $ea_level = get_ea_level($wp_user_id);
            if (isset($pledge_level) || isset($founder_level) || isset($ea_level)) {
                if ($pledge_level >= 1 || $founder_level >= 1 || $ea_level >= 1) {
                    return 2;
                } else {
                    return 1;
                }
            } else {
                return 1;
            }
        } else {
            return 0;
        }
    }
}